

' VBA declare statements for NAG Fortran Library DLL Mark 29.3
' Copyright 2023, Numerical Algorithms Group Ltd, Oxford, UK.
' chapter x01

   Declare Ptrsafe Function X01AAF Lib "NLW32293E_nag.dll" ( _
    ByRef x As double _
   ) As double


   Declare Ptrsafe Function X01ABF Lib "NLW32293E_nag.dll" ( _
    ByRef x As double _
   ) As double


' chapter x02

   Declare Ptrsafe Function X02AHF Lib "NLW32293E_nag.dll" ( _
    ByRef x As double _
   ) As double


   Declare Ptrsafe Function X02AJF Lib "NLW32293E_nag.dll" ( _
   ) As double


   Declare Ptrsafe Function X02AKF Lib "NLW32293E_nag.dll" ( _
   ) As double


   Declare Ptrsafe Function X02ALF Lib "NLW32293E_nag.dll" ( _
   ) As double


   Declare Ptrsafe Function X02AMF Lib "NLW32293E_nag.dll" ( _
   ) As double


   Declare Ptrsafe Function X02ANF Lib "NLW32293E_nag.dll" ( _
   ) As double


   Declare Ptrsafe Function X02BBF Lib "NLW32293E_nag.dll" ( _
    ByRef x As double _
   ) As long


   Declare Ptrsafe Function X02BEF Lib "NLW32293E_nag.dll" ( _
    ByRef x As double _
   ) As long


   Declare Ptrsafe Function X02BHF Lib "NLW32293E_nag.dll" ( _
   ) As long


   Declare Ptrsafe Function X02BJF Lib "NLW32293E_nag.dll" ( _
   ) As long


   Declare Ptrsafe Function X02BKF Lib "NLW32293E_nag.dll" ( _
   ) As long


   Declare Ptrsafe Function X02BLF Lib "NLW32293E_nag.dll" ( _
   ) As long


' chapter x03

   Declare Ptrsafe Sub X03AAF Lib "NLW32293E_nag.dll" ( _
    ByRef a As double, _
    ByRef isizea As long, _
    ByRef b As double, _
    ByRef isizeb As long, _
    ByRef n As long, _
    ByRef istepa As long, _
    ByRef istepb As long, _
    ByRef c1 As double, _
    ByRef c2 As double, _
    ByRef d1 As double, _
    ByRef d2 As double, _
    ByRef sw As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X03ABF Lib "NLW32293E_nag.dll" ( _
    ByRef a As Complex, _
    ByRef isizea As long, _
    ByRef b As Complex, _
    ByRef isizeb As long, _
    ByRef n As long, _
    ByRef istepa As long, _
    ByRef istepb As long, _
    ByRef cx As Complex, _
    ByRef dx As Complex, _
    ByRef sw As long, _
    ByRef ifail As long _
   )


' chapter x04

   Declare Ptrsafe Sub X04AAF Lib "NLW32293E_nag.dll" ( _
    ByRef iflag As long, _
    ByRef nerr As long _
   )


   Declare Ptrsafe Sub X04ABF Lib "NLW32293E_nag.dll" ( _
    ByRef iflag As long, _
    ByRef nadv As long _
   )


   Declare Ptrsafe Sub X04ACF Lib "NLW32293E_nag.dll" ( _
    ByRef iounit As long, _
    ByVal file As string, ByVal filelength As long, _
    ByRef mode As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04ADF Lib "NLW32293E_nag.dll" ( _
    ByRef iounit As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04BAF Lib "NLW32293E_nag.dll" ( _
    ByRef nout As long, _
    ByVal rec As string, ByVal reclength As long _
   )


   Declare Ptrsafe Sub X04BBF Lib "NLW32293E_nag.dll" ( _
    ByRef nin As long, _
    ByVal recin As string, ByVal recinlength As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04CAF Lib "NLW32293E_nag.dll" ( _
    ByVal matrix As string, ByVal matrixlength As long, _
    ByVal diag As string, ByVal diaglength As long, _
    ByRef m As long, _
    ByRef n As long, _
    ByRef a As double, _
    ByRef lda As long, _
    ByVal title As string, ByVal titlelength As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04CBF Lib "NLW32293E_nag.dll" ( _
    ByVal matrix As string, ByVal matrixlength As long, _
    ByVal diag As string, ByVal diaglength As long, _
    ByRef m As long, _
    ByRef n As long, _
    ByRef a As double, _
    ByRef lda As long, _
    ByVal form As string, ByVal formlength As long, _
    ByVal title As string, ByVal titlelength As long, _
    ByVal labrow As string, ByVal labrowlength As long, _
    ByVal rlabs As string, ByVal rlabslength As long, _
    ByVal labcol As string, ByVal labcollength As long, _
    ByVal clabs As string, ByVal clabslength As long, _
    ByRef ncols As long, _
    ByRef indent As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04CCF Lib "NLW32293E_nag.dll" ( _
    ByVal uplo As string, ByVal uplolength As long, _
    ByVal diag As string, ByVal diaglength As long, _
    ByRef n As long, _
    ByRef a As double, _
    ByVal title As string, ByVal titlelength As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04CDF Lib "NLW32293E_nag.dll" ( _
    ByVal uplo As string, ByVal uplolength As long, _
    ByVal diag As string, ByVal diaglength As long, _
    ByRef n As long, _
    ByRef a As double, _
    ByVal form As string, ByVal formlength As long, _
    ByVal title As string, ByVal titlelength As long, _
    ByVal labrow As string, ByVal labrowlength As long, _
    ByVal rlabs As string, ByVal rlabslength As long, _
    ByVal labcol As string, ByVal labcollength As long, _
    ByVal clabs As string, ByVal clabslength As long, _
    ByRef ncols As long, _
    ByRef indent As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04CEF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef n As long, _
    ByRef kl As long, _
    ByRef ku As long, _
    ByRef a As double, _
    ByRef lda As long, _
    ByVal title As string, ByVal titlelength As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04CFF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef n As long, _
    ByRef kl As long, _
    ByRef ku As long, _
    ByRef a As double, _
    ByRef lda As long, _
    ByVal form As string, ByVal formlength As long, _
    ByVal title As string, ByVal titlelength As long, _
    ByVal labrow As string, ByVal labrowlength As long, _
    ByVal rlabs As string, ByVal rlabslength As long, _
    ByVal labcol As string, ByVal labcollength As long, _
    ByVal clabs As string, ByVal clabslength As long, _
    ByRef ncols As long, _
    ByRef indent As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04DAF Lib "NLW32293E_nag.dll" ( _
    ByVal matrix As string, ByVal matrixlength As long, _
    ByVal diag As string, ByVal diaglength As long, _
    ByRef m As long, _
    ByRef n As long, _
    ByRef a As Complex, _
    ByRef lda As long, _
    ByVal title As string, ByVal titlelength As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04DBF Lib "NLW32293E_nag.dll" ( _
    ByVal matrix As string, ByVal matrixlength As long, _
    ByVal diag As string, ByVal diaglength As long, _
    ByRef m As long, _
    ByRef n As long, _
    ByRef a As Complex, _
    ByRef lda As long, _
    ByVal usefrm As string, ByVal usefrmlength As long, _
    ByVal form As string, ByVal formlength As long, _
    ByVal title As string, ByVal titlelength As long, _
    ByVal labrow As string, ByVal labrowlength As long, _
    ByVal rlabs As string, ByVal rlabslength As long, _
    ByVal labcol As string, ByVal labcollength As long, _
    ByVal clabs As string, ByVal clabslength As long, _
    ByRef ncols As long, _
    ByRef indent As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04DCF Lib "NLW32293E_nag.dll" ( _
    ByVal uplo As string, ByVal uplolength As long, _
    ByVal diag As string, ByVal diaglength As long, _
    ByRef n As long, _
    ByRef a As Complex, _
    ByVal title As string, ByVal titlelength As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04DDF Lib "NLW32293E_nag.dll" ( _
    ByVal uplo As string, ByVal uplolength As long, _
    ByVal diag As string, ByVal diaglength As long, _
    ByRef n As long, _
    ByRef a As Complex, _
    ByVal usefrm As string, ByVal usefrmlength As long, _
    ByVal form As string, ByVal formlength As long, _
    ByVal title As string, ByVal titlelength As long, _
    ByVal labrow As string, ByVal labrowlength As long, _
    ByVal rlabs As string, ByVal rlabslength As long, _
    ByVal labcol As string, ByVal labcollength As long, _
    ByVal clabs As string, ByVal clabslength As long, _
    ByRef ncols As long, _
    ByRef indent As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04DEF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef n As long, _
    ByRef kl As long, _
    ByRef ku As long, _
    ByRef a As Complex, _
    ByRef lda As long, _
    ByVal title As string, ByVal titlelength As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04DFF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef n As long, _
    ByRef kl As long, _
    ByRef ku As long, _
    ByRef a As Complex, _
    ByRef lda As long, _
    ByVal usefrm As string, ByVal usefrmlength As long, _
    ByVal form As string, ByVal formlength As long, _
    ByVal title As string, ByVal titlelength As long, _
    ByVal labrow As string, ByVal labrowlength As long, _
    ByVal rlabs As string, ByVal rlabslength As long, _
    ByVal labcol As string, ByVal labcollength As long, _
    ByVal clabs As string, ByVal clabslength As long, _
    ByRef ncols As long, _
    ByRef indent As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04EAF Lib "NLW32293E_nag.dll" ( _
    ByVal matrix As string, ByVal matrixlength As long, _
    ByVal diag As string, ByVal diaglength As long, _
    ByRef m As long, _
    ByRef n As long, _
    ByRef a As long, _
    ByRef lda As long, _
    ByVal title As string, ByVal titlelength As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub X04EBF Lib "NLW32293E_nag.dll" ( _
    ByVal matrix As string, ByVal matrixlength As long, _
    ByVal diag As string, ByVal diaglength As long, _
    ByRef m As long, _
    ByRef n As long, _
    ByRef a As long, _
    ByRef lda As long, _
    ByVal form As string, ByVal formlength As long, _
    ByVal title As string, ByVal titlelength As long, _
    ByVal labrow As string, ByVal labrowlength As long, _
    ByVal rlabs As string, ByVal rlabslength As long, _
    ByVal labcol As string, ByVal labcollength As long, _
    ByVal clabs As string, ByVal clabslength As long, _
    ByRef ncols As long, _
    ByRef indent As long, _
    ByRef ifail As long _
   )


' chapter x05

   Declare Ptrsafe Sub X05AAF Lib "NLW32293E_nag.dll" ( _
    ByRef itime As long _
   )


   Declare Ptrsafe Sub X05ABF Lib "NLW32293E_nag.dll" ( _
    ByVal retval As string, ByVal retvallength As long, _
    ByRef itime As long _
   )


   Declare Ptrsafe Function X05ACF Lib "NLW32293E_nag.dll" ( _
    ByVal ctime1 As string, ByVal ctime1length As long, _
    ByVal ctime2 As string, ByVal ctime2length As long _
   ) As long


   Declare Ptrsafe Function X05BAF Lib "NLW32293E_nag.dll" ( _
   ) As double


' chapter x06

   Declare Ptrsafe Sub X06AAF Lib "NLW32293E_nag.dll" ( _
    ByRef num As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Function X06ABF Lib "NLW32293E_nag.dll" ( _
   ) As long


   Declare Ptrsafe Function X06ACF Lib "NLW32293E_nag.dll" ( _
   ) As long


   Declare Ptrsafe Function X06ADF Lib "NLW32293E_nag.dll" ( _
   ) As long


   Declare Ptrsafe Function X06AFF Lib "NLW32293E_nag.dll" ( _
   ) As long


   Declare Ptrsafe Sub X06AGF Lib "NLW32293E_nag.dll" ( _
    ByRef nesting As long _
   )


   Declare Ptrsafe Function X06AHF Lib "NLW32293E_nag.dll" ( _
   ) As long


   Declare Ptrsafe Sub X06AJF Lib "NLW32293E_nag.dll" ( _
    ByRef num As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Function X06AKF Lib "NLW32293E_nag.dll" ( _
   ) As long


   Declare Ptrsafe Function X06XAF Lib "NLW32293E_nag.dll" ( _
   ) As long


' chapter x07

   Declare Ptrsafe Function X07AAF Lib "NLW32293E_nag.dll" ( _
    ByRef x As double _
   ) As long


   Declare Ptrsafe Function X07ABF Lib "NLW32293E_nag.dll" ( _
    ByRef x As double _
   ) As long


   Declare Ptrsafe Sub X07BAF Lib "NLW32293E_nag.dll" ( _
    ByRef isign As long, _
    ByRef x As double _
   )


   Declare Ptrsafe Sub X07BBF Lib "NLW32293E_nag.dll" ( _
    ByRef quiet As long, _
    ByRef x As double _
   )


   Declare Ptrsafe Sub X07CAF Lib "NLW32293E_nag.dll" ( _
    ByRef exceptionmode As long _
   )


   Declare Ptrsafe Sub X07CBF Lib "NLW32293E_nag.dll" ( _
    ByRef exceptionmode As long _
   )


